I recently tried to upgrade from 2.9 to 4.2.  I had 10 nop websites that needed upgrading.  Getting error upon error, i got some help from fellow nop user named Saurabhdhi.  He helped me through a few of the first errors.  I eventually just had him to the complete upgrades on all 10 sites.  He was amazingly cheap, fast and thorough.  He even upgraded my plugins.

Go see saurabhdhir you can PM him from here for help or even have him do it.:

https://www.nopcommerce.com/boards/topic/67663/availability-of-paypal-direct-plug-in-in-nopcommerce-420